// AMD Interwave local ROM\DRAM dumper - by wbcbz7 zq.oz.zolb
// outputs IWDRAM.BIN and IWROM.BIN files (16 MB each, full dump)

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include "iwdump.h"

FILE          *f;
int           iw_baseport;
unsigned char buffer[BUF_SIZE];

void iwread(unsigned long pos, void *data, unsigned long length, int rom) {
    int i;
    unsigned char *buf = (unsigned char*)data;
     
    rom = (rom & 1) << 1;
    
    outp (iw_baseport+IW_PIDX,   IW_LMCI);
    outp (iw_baseport+IW_PDATAH, (inp(iw_baseport+IW_PDATAH) | rom));
    
    outp (iw_baseport+IW_PIDX,   IW_LMALI);
    outpw(iw_baseport+IW_PDATAH, (pos & 0xFFFF));
    outp (iw_baseport+IW_PIDX,   IW_LMALH);
    outp (iw_baseport+IW_PDATAH, (pos >> 16));
    
    for (i = 0; i < length; i++) {
        buf[i] = inp(iw_baseport+IW_LMBDR);
    }
    
    outp (iw_baseport+IW_PIDX,   IW_LMCI);
    outp (iw_baseport+IW_PDATAH, (inp(iw_baseport+IW_PDATAH) & ~rom));
}

int iwgetport() {
    char *env = getenv("ULTRASND");
    int  port, dummy;
    
    if (!env) return 0;
    sscanf(env, "%x,%d,%d,%d,%d", &port, &dummy, &dummy, &dummy, &dummy);
    return port;
}

int main() {
    int i, j, pos = 0;
    
    puts("AMD Interwave local ROM\\DRAM dumper - by wbcbz7 28.02.2016");
    iw_baseport = iwgetport();
    if (iw_baseport == 0) {puts("can't get Interwave base port - check ULTRASND environment varable"); exit(1);}
    
    cputs("dumping ROM content, please wait");
    f = fopen(ROM_FILE, "wb");
    for (i = 0; i < (TOTAL_MEM / BUF_SIZE); i++) {
        iwread(pos, &buffer, BUF_SIZE, 1);
        fwrite(&buffer, sizeof(buffer), 1, f);
        pos += BUF_SIZE;
        if (i & 0x40) cputs(".");
    }
    fclose(f);
    puts("");
    
    pos = 0;
    cputs("dumping DRAM content, please wait");
    f = fopen(RAM_FILE, "wb");
    for (i = 0; i < (TOTAL_MEM / BUF_SIZE); i++) {
        iwread(pos, &buffer, BUF_SIZE, 0);
        fwrite(&buffer, sizeof(buffer), 1, f);
        pos += BUF_SIZE;
        if (i & 0x40) cputs(".");
    }
    fclose(f);
    
    puts("\ndone");
}
